/* DateRange.c generated by valac 0.56.17, the Vala compiler
 * generated from DateRange.vala, do not modify */

/*
 * Copyright 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */
/* Represents date range from 'first' to 'last' inclusive */

#include "elementary-calendar.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CALENDAR_UTIL_DATE_RANGE_0_PROPERTY,
	CALENDAR_UTIL_DATE_RANGE_FIRST_DT_PROPERTY,
	CALENDAR_UTIL_DATE_RANGE_LAST_DT_PROPERTY,
	CALENDAR_UTIL_DATE_RANGE_NUM_PROPERTIES
};
static GParamSpec* calendar_util_date_range_properties[CALENDAR_UTIL_DATE_RANGE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CalendarUtilDateRangePrivate {
	GDateTime* _first_dt;
	GDateTime* _last_dt;
};

static gint CalendarUtilDateRange_private_offset;
static gpointer calendar_util_date_range_parent_class = NULL;
static GeeTraversableIface * calendar_util_date_range_gee_traversable_parent_iface = NULL;
static GeeIterableIface * calendar_util_date_range_gee_iterable_parent_iface = NULL;

static gboolean calendar_util_date_range_real_foreach (GeeTraversable* base,
                                                GeeForallFunc f,
                                                gpointer f_target);
static GeeIterator* calendar_util_date_range_real_iterator (GeeIterable* base);
static void calendar_util_date_range_finalize (GObject * obj);
static GType calendar_util_date_range_get_type_once (void);
static void _vala_calendar_util_date_range_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_calendar_util_date_range_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
calendar_util_date_range_get_instance_private (CalendarUtilDateRange* self)
{
	return G_STRUCT_MEMBER_P (self, CalendarUtilDateRange_private_offset);
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 29 "../core/Services/Calendar/Util/DateRange.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 87 "DateRange.c"
}

static gboolean
calendar_util_date_range_real_foreach (GeeTraversable* base,
                                       GeeForallFunc f,
                                       gpointer f_target)
{
	CalendarUtilDateRange * self;
	gboolean result;
#line 27 "../core/Services/Calendar/Util/DateRange.vala"
	self = (CalendarUtilDateRange*) base;
#line 99 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp0_;
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) self);
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
		_date_it = _tmp0_;
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
		while (TRUE) {
#line 109 "DateRange.c"
			GeeIterator* _tmp1_;
			GDateTime* date = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GDateTime* _tmp4_;
			GDateTime* _tmp5_;
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp1_ = _date_it;
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
				break;
#line 122 "DateRange.c"
			}
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp2_ = _date_it;
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
			date = (GDateTime*) _tmp3_;
#line 29 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp4_ = date;
#line 29 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp5_ = _g_date_time_ref0 (_tmp4_);
#line 29 "../core/Services/Calendar/Util/DateRange.vala"
			if (f (_tmp5_, f_target) == FALSE) {
#line 30 "../core/Services/Calendar/Util/DateRange.vala"
				result = FALSE;
#line 30 "../core/Services/Calendar/Util/DateRange.vala"
				_g_date_time_unref0 (date);
#line 30 "../core/Services/Calendar/Util/DateRange.vala"
				_g_object_unref0 (_date_it);
#line 30 "../core/Services/Calendar/Util/DateRange.vala"
				return result;
#line 144 "DateRange.c"
			}
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
			_g_date_time_unref0 (date);
#line 148 "DateRange.c"
		}
#line 28 "../core/Services/Calendar/Util/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 152 "DateRange.c"
	}
#line 34 "../core/Services/Calendar/Util/DateRange.vala"
	result = TRUE;
#line 34 "../core/Services/Calendar/Util/DateRange.vala"
	return result;
#line 158 "DateRange.c"
}

CalendarUtilDateRange*
calendar_util_date_range_construct (GType object_type,
                                    GDateTime* first,
                                    GDateTime* last)
{
	CalendarUtilDateRange * self = NULL;
#line 37 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_val_if_fail (first != NULL, NULL);
#line 37 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_val_if_fail (last != NULL, NULL);
#line 38 "../core/Services/Calendar/Util/DateRange.vala"
	self = (CalendarUtilDateRange*) g_object_new (object_type, "first-dt", first, "last-dt", last, NULL);
#line 37 "../core/Services/Calendar/Util/DateRange.vala"
	return self;
#line 175 "DateRange.c"
}

CalendarUtilDateRange*
calendar_util_date_range_new (GDateTime* first,
                              GDateTime* last)
{
#line 37 "../core/Services/Calendar/Util/DateRange.vala"
	return calendar_util_date_range_construct (CALENDAR_UTIL_TYPE_DATE_RANGE, first, last);
#line 184 "DateRange.c"
}

gboolean
calendar_util_date_range_equals (CalendarUtilDateRange* self,
                                 CalendarUtilDateRange* other)
{
	gboolean _tmp0_ = FALSE;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean result;
#line 44 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
	_tmp1_ = self->priv->_first_dt;
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
	_tmp2_ = other->priv->_first_dt;
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
	if (_tmp1_ == _tmp2_) {
#line 205 "DateRange.c"
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp3_ = self->priv->_last_dt;
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp4_ = other->priv->_last_dt;
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp0_ = _tmp3_ == _tmp4_;
#line 214 "DateRange.c"
	} else {
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp0_ = FALSE;
#line 218 "DateRange.c"
	}
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
	result = _tmp0_;
#line 45 "../core/Services/Calendar/Util/DateRange.vala"
	return result;
#line 224 "DateRange.c"
}

static GeeIterator*
calendar_util_date_range_real_iterator (GeeIterable* base)
{
	CalendarUtilDateRange * self;
	CalendarUtilDateIterator* _tmp0_;
	GeeIterator* result;
#line 48 "../core/Services/Calendar/Util/DateRange.vala"
	self = (CalendarUtilDateRange*) base;
#line 49 "../core/Services/Calendar/Util/DateRange.vala"
	_tmp0_ = calendar_util_date_iterator_new (self);
#line 49 "../core/Services/Calendar/Util/DateRange.vala"
	result = (GeeIterator*) _tmp0_;
#line 49 "../core/Services/Calendar/Util/DateRange.vala"
	return result;
#line 241 "DateRange.c"
}

GeeList*
calendar_util_date_range_to_list (CalendarUtilDateRange* self)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 52 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../core/Services/Calendar/Util/DateRange.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_DATE_TIME, (GBoxedCopyFunc) g_date_time_ref, (GDestroyNotify) g_date_time_unref, (GeeEqualDataFunc) calendar_util_datetime_equal_func, NULL, NULL);
#line 53 "../core/Services/Calendar/Util/DateRange.vala"
	list = _tmp0_;
#line 256 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp1_;
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) self);
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
		_date_it = _tmp1_;
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
		while (TRUE) {
#line 266 "DateRange.c"
			GeeIterator* _tmp2_;
			GDateTime* date = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			GDateTime* _tmp6_;
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp2_ = _date_it;
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
				break;
#line 279 "DateRange.c"
			}
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp3_ = _date_it;
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
			date = (GDateTime*) _tmp4_;
#line 56 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp5_ = list;
#line 56 "../core/Services/Calendar/Util/DateRange.vala"
			_tmp6_ = date;
#line 56 "../core/Services/Calendar/Util/DateRange.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
			_g_date_time_unref0 (date);
#line 295 "DateRange.c"
		}
#line 55 "../core/Services/Calendar/Util/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 299 "DateRange.c"
	}
#line 59 "../core/Services/Calendar/Util/DateRange.vala"
	result = (GeeList*) list;
#line 59 "../core/Services/Calendar/Util/DateRange.vala"
	return result;
#line 305 "DateRange.c"
}

GDateTime*
calendar_util_date_range_get_first_dt (CalendarUtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	_tmp0_ = self->priv->_first_dt;
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	result = _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	return result;
#line 321 "DateRange.c"
}

static void
calendar_util_date_range_set_first_dt (CalendarUtilDateRange* self,
                                       GDateTime* value)
{
	GDateTime* old_value;
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	old_value = calendar_util_date_range_get_first_dt (self);
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	if (old_value != value) {
#line 335 "DateRange.c"
		GDateTime* _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
		_g_date_time_unref0 (self->priv->_first_dt);
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
		self->priv->_first_dt = _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_util_date_range_properties[CALENDAR_UTIL_DATE_RANGE_FIRST_DT_PROPERTY]);
#line 345 "DateRange.c"
	}
}

GDateTime*
calendar_util_date_range_get_last_dt (CalendarUtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	_tmp0_ = self->priv->_last_dt;
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	result = _tmp0_;
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	return result;
#line 362 "DateRange.c"
}

static void
calendar_util_date_range_set_last_dt (CalendarUtilDateRange* self,
                                      GDateTime* value)
{
	GDateTime* old_value;
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	old_value = calendar_util_date_range_get_last_dt (self);
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	if (old_value != value) {
#line 376 "DateRange.c"
		GDateTime* _tmp0_;
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
		_g_date_time_unref0 (self->priv->_last_dt);
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
		self->priv->_last_dt = _tmp0_;
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_util_date_range_properties[CALENDAR_UTIL_DATE_RANGE_LAST_DT_PROPERTY]);
#line 386 "DateRange.c"
	}
}

static void
calendar_util_date_range_class_init (CalendarUtilDateRangeClass * klass,
                                     gpointer klass_data)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	calendar_util_date_range_parent_class = g_type_class_peek_parent (klass);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	g_type_class_adjust_private_offset (klass, &CalendarUtilDateRange_private_offset);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_calendar_util_date_range_get_property;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_calendar_util_date_range_set_property;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	G_OBJECT_CLASS (klass)->finalize = calendar_util_date_range_finalize;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_UTIL_DATE_RANGE_FIRST_DT_PROPERTY, calendar_util_date_range_properties[CALENDAR_UTIL_DATE_RANGE_FIRST_DT_PROPERTY] = g_param_spec_boxed ("first-dt", "first-dt", "first-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_UTIL_DATE_RANGE_LAST_DT_PROPERTY, calendar_util_date_range_properties[CALENDAR_UTIL_DATE_RANGE_LAST_DT_PROPERTY] = g_param_spec_boxed ("last-dt", "last-dt", "last-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 408 "DateRange.c"
}

static GType
calendar_util_date_range_gee_traversable_get_g_type (CalendarUtilDateRange* self)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 416 "DateRange.c"
}

static GBoxedCopyFunc
calendar_util_date_range_gee_traversable_get_g_dup_func (CalendarUtilDateRange* self)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 424 "DateRange.c"
}

static GDestroyNotify
calendar_util_date_range_gee_traversable_get_g_destroy_func (CalendarUtilDateRange* self)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 432 "DateRange.c"
}

static void
calendar_util_date_range_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                         gpointer iface_data)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	calendar_util_date_range_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) calendar_util_date_range_real_foreach;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) calendar_util_date_range_gee_traversable_get_g_type;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) calendar_util_date_range_gee_traversable_get_g_dup_func;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) calendar_util_date_range_gee_traversable_get_g_destroy_func;
#line 449 "DateRange.c"
}

static GType
calendar_util_date_range_gee_iterable_get_g_type (CalendarUtilDateRange* self)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 457 "DateRange.c"
}

static GBoxedCopyFunc
calendar_util_date_range_gee_iterable_get_g_dup_func (CalendarUtilDateRange* self)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 465 "DateRange.c"
}

static GDestroyNotify
calendar_util_date_range_gee_iterable_get_g_destroy_func (CalendarUtilDateRange* self)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 473 "DateRange.c"
}

static void
calendar_util_date_range_gee_iterable_interface_init (GeeIterableIface * iface,
                                                      gpointer iface_data)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	calendar_util_date_range_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->iterator = (GeeIterator* (*) (GeeIterable*)) calendar_util_date_range_real_iterator;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeIterable *)) calendar_util_date_range_gee_iterable_get_g_type;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) calendar_util_date_range_gee_iterable_get_g_dup_func;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) calendar_util_date_range_gee_iterable_get_g_destroy_func;
#line 490 "DateRange.c"
}

static void
calendar_util_date_range_instance_init (CalendarUtilDateRange * self,
                                        gpointer klass)
{
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	self->priv = calendar_util_date_range_get_instance_private (self);
#line 499 "DateRange.c"
}

static void
calendar_util_date_range_finalize (GObject * obj)
{
	CalendarUtilDateRange * self;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALENDAR_UTIL_TYPE_DATE_RANGE, CalendarUtilDateRange);
#line 24 "../core/Services/Calendar/Util/DateRange.vala"
	_g_date_time_unref0 (self->priv->_first_dt);
#line 25 "../core/Services/Calendar/Util/DateRange.vala"
	_g_date_time_unref0 (self->priv->_last_dt);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	G_OBJECT_CLASS (calendar_util_date_range_parent_class)->finalize (obj);
#line 514 "DateRange.c"
}

static GType
calendar_util_date_range_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CalendarUtilDateRangeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) calendar_util_date_range_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CalendarUtilDateRange), 0, (GInstanceInitFunc) calendar_util_date_range_instance_init, NULL };
	static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) calendar_util_date_range_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) calendar_util_date_range_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType calendar_util_date_range_type_id;
	calendar_util_date_range_type_id = g_type_register_static (G_TYPE_OBJECT, "CalendarUtilDateRange", &g_define_type_info, 0);
	g_type_add_interface_static (calendar_util_date_range_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
	g_type_add_interface_static (calendar_util_date_range_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
	CalendarUtilDateRange_private_offset = g_type_add_instance_private (calendar_util_date_range_type_id, sizeof (CalendarUtilDateRangePrivate));
	return calendar_util_date_range_type_id;
}

GType
calendar_util_date_range_get_type (void)
{
	static volatile gsize calendar_util_date_range_type_id__once = 0;
	if (g_once_init_enter (&calendar_util_date_range_type_id__once)) {
		GType calendar_util_date_range_type_id;
		calendar_util_date_range_type_id = calendar_util_date_range_get_type_once ();
		g_once_init_leave (&calendar_util_date_range_type_id__once, calendar_util_date_range_type_id);
	}
	return calendar_util_date_range_type_id__once;
}

static void
_vala_calendar_util_date_range_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	CalendarUtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_UTIL_TYPE_DATE_RANGE, CalendarUtilDateRange);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	switch (property_id) {
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		case CALENDAR_UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		g_value_set_boxed (value, calendar_util_date_range_get_first_dt (self));
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		break;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		case CALENDAR_UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		g_value_set_boxed (value, calendar_util_date_range_get_last_dt (self));
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		break;
#line 565 "DateRange.c"
		default:
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		break;
#line 571 "DateRange.c"
	}
}

static void
_vala_calendar_util_date_range_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	CalendarUtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_UTIL_TYPE_DATE_RANGE, CalendarUtilDateRange);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
	switch (property_id) {
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		case CALENDAR_UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		calendar_util_date_range_set_first_dt (self, g_value_get_boxed (value));
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		break;
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		case CALENDAR_UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		calendar_util_date_range_set_last_dt (self, g_value_get_boxed (value));
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		break;
#line 597 "DateRange.c"
		default:
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../core/Services/Calendar/Util/DateRange.vala"
		break;
#line 603 "DateRange.c"
	}
}

